> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create a reusable block

POST https://rest.test.zuora.com/notifications/reusable-blocks
Content-Type: application/json

Creates a reusable block for email templates, such as email headers or footers.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/events-and-notifications/notifications/create-reusable-block

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

### Body (application/json)

This endpoint expects a CreatePublicReusableBlockRequest.

- `category` (enum, required) — The category of the reusable block. You can filter blocks by category when editing email templates in the UI.
  - Allowed values: `Headers`, `Footers`, `Other`
- `content` (string, required) — The content of the reusable block, which is automatically inserted into email templates when sending email notifications.
- `name` (string, required) — The name of the reusable block. The value must be unique across all blocks.
- `active` (boolean, optional, default: true) — The status of the reusable block. Only active blocks can be embedded into email templates.
- `number` (string, optional) — The number of the reusable block. The value must be unique across all blocks. If not specified, a unique value will be provided by default.
- `tags` (list of string, optional) — List of tags that help you quickly locate reusable blocks when editing email templates in the UI by using the tag filter.

## Response

### 200

OK

- `active` (boolean, optional, default: true) — The status of the reusable block. Only active blocks can be embedded into email templates.
- `category` (enum, optional) — The category of the reusable block. You can filter blocks by category when editing email templates in the UI.
  - Allowed values: `Headers`, `Footers`, `Other`
- `content` (string, optional) — The content of the reusable block, which is automatically inserted into email templates when sending email notifications.
- `createdBy` (string, optional) — The ID of the user who created the reusable block.
- `createdOn` (datetime, optional) — The time when the reusable block was created.
- `id` (string, optional) — The ID of the reusable block.
- `name` (string, optional) — The name of the reusable block. The value must be unique across all blocks.
- `number` (string, optional) — The number of the reusable block. The value must be unique across all blocks. If not specified, a unique value will be provided by default.
- `tags` (list of string, optional) — List of tags that help you quickly locate reusable blocks when editing email templates in the UI by using the tag filter.
- `updatedBy` (string, optional) — The ID of the user who updated the reusable block.
- `updatedOn` (datetime, optional) — TThe time when the reusable block was updated.

## Errors

### 400 Bad Request Error

Bad Request

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 404 Not Found Error

Not Found

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 405 Method Not Allowed Error

Method Not Allowed

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 415 Unsupported Media Type Error

Unsupported Media Type

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

## Types

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "category": "Headers",
  "content": "(The content of the block)",
  "name": "Header Block"
}
```

**Response**

```json
{
  "active": true,
  "category": "Headers",
  "content": "(The content of the block)",
  "createdBy": "8a90e08282f4ed040182f67bab2902ff",
  "createdOn": "2025-04-22T08:17:24.000 UTC",
  "id": "c6af751e4a0041eebb000c51e95e6c2d",
  "name": "Header Block",
  "number": "RB-00000010",
  "tags": [],
  "updatedBy": "8a90e08282f4ed040182f67bab2902ff",
  "updatedOn": "2025-04-22T08:17:24.000 UTC"
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/notifications/reusable-blocks"

payload = {
    "category": "Headers",
    "content": "(The content of the block)",
    "name": "Header Block"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/notifications/reusable-blocks';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"category":"Headers","content":"(The content of the block)","name":"Header Block"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/notifications/reusable-blocks"

	payload := strings.NewReader("{\n  \"category\": \"Headers\",\n  \"content\": \"(The content of the block)\",\n  \"name\": \"Header Block\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/notifications/reusable-blocks")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"category\": \"Headers\",\n  \"content\": \"(The content of the block)\",\n  \"name\": \"Header Block\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/notifications/reusable-blocks")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"category\": \"Headers\",\n  \"content\": \"(The content of the block)\",\n  \"name\": \"Header Block\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/notifications/reusable-blocks', [
  'body' => '{
  "category": "Headers",
  "content": "(The content of the block)",
  "name": "Header Block"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/notifications/reusable-blocks");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"category\": \"Headers\",\n  \"content\": \"(The content of the block)\",\n  \"name\": \"Header Block\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "category": "Headers",
  "content": "(The content of the block)",
  "name": "Header Block"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/notifications/reusable-blocks")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```